; ***********************************************************
; *    (   ) *
; ***********************************************************   
; *   :              AVR Studio v.4.13       *
; *  :                     ATmega8(V)              *
; *   :                                    *
; *    PC0,PC1,PC2,PC3,PD4,PD5,PD6,PD7 -                    *
; *         A,B,C,D,E,F,G,H                 * 
; *    PB3,PB4,PB5 -  / X0,X1,X2  *
; *    PC4 -                          *
; *    PD0,PD1,PD2 -    SB3,SB1,SB2   *
; *    PB1  -                            *
; *   : 4  ( )                *
; *        Low Fuse                     High Fuse           * 
; *      BODLEVEL = 1                  RSTDISBL = 1         *    
; *      BODEN    = 0                  WDTON    = 1         *
; *      SUT1     = 1                  SPIEN    = 0         *
; *      SUT0     = 1                  CKOPT    = 0         *
; *      CKSEL3   = 1                  EESAVE   = 0         *
; *      CKSEL2   = 1                  BOOTSZ1  = 1         * 
; *      CKSEL1   = 1                  BOOTSZ0  = 1         *
; *      CKSEL0   = 1                  BOOTRST  = 1         * 
; *  FLASH:              8172                           *  
; *  SRAM:                 47                           *
; *  EEPROM:               80                           *               
; *                                        kotov_ig@mail.ru *
; ***********************************************************

	     .nolist
        .include "m8def.inc"
         .list

    .equ  POV    =  PB2
	.equ  DS     =  PC4

	.equ  PORTDS =  PORTC
	.equ  DDRDS  =  PORTC-1
	.equ  PINDS  =  PORTC-2

	.equ  PRESS  =  40

    .equ  X0     = PB3   ;  / 0
    .equ  X1     = PB4   ;  / 1
    .equ  X2     = PB5   ;  / 2

	.def  zero   = R0    ; 
	.def  tskn   = R1    ; 

	.def  temp   = R16   ;   
    .def  temp1  = R17 
    .def  temp2  = R18 
    .def  temp3  = R19 
	.def  buton  = R20   ;  
	.def  flag   = R21   ;  
	.def  picter = R22   ; 
	.def  wait   = R23   ;      
	.def  wrdlo  = R24   ;  
    .def  wrdhi  = R25   ;  

    #define __COMMON_CATODE__
  #ifdef __COMMON_CATODE__
	#define  SEG_A  1<<0
	#define  SEG_B  1<<2
	#define  SEG_C  1<<4
	#define  SEG_D  1<<7
	#define  SEG_E  1<<6
	#define  SEG_F  1<<1
	#define  SEG_G  1<<3
	#define  SEG_H  1<<5
  #else
	#define  SEG_A  ~(1<<0)
	#define  SEG_B  ~(1<<1)
	#define  SEG_C  ~(1<<2)
	#define  SEG_D  ~(1<<3)
	#define  SEG_E  ~(1<<4)
	#define  SEG_F  ~(1<<5)
	#define  SEG_G  ~(1<<6)
	#define  SEG_H  ~(1<<7)
  #endif


;            indcon
; 0 - /  0 (1/0)  
; 1 - /  1 (1/0)
; 2 - /  2 (1/0)
; 3 - /   0 (1/0)
; 4 - /   1 (1/0)
; 5 - /   2 (1/0)
; 6 -    4  
; 7 -    2  

           .dseg
	   .org  SRAM_START

     dsnum  :  .byte  16 ;ID-  
	 shift  :  .byte  1  ; 
     errcnt :  .byte  1  ; 
     tsavlo :  .byte  1  ;    
     tsavhi :  .byte  1  ;    
     savind :  .byte  1  ; indcon
 	 blink  :  .byte  1  ; 
	 dello  :  .byte  1  ;  
     delhi  :  .byte  1  ;  
	 savelo :  .byte  1  ;   
     savehi :  .byte  1  ;   
	 offlo  :  .byte  1  ;    
     offhi  :  .byte  1  ;    
	 onlo   :  .byte  1  ;    
     onhi   :  .byte  1  ;    
     seclo  :  .byte  1  ;   
	 sechi  :  .byte  1  ;   
     prs1   :  .byte  1  ;   1
	 prs2lo :  .byte  1  ;     2
     prs2hi :  .byte  1  ;     2
	 poslo  :  .byte  1  ;   
	 poshi  :  .byte  1  ;   
	 ind0   :  .byte  1  ; 0  
	 ind1   :  .byte  1  ; 1  
	 ind2   :  .byte  1  ; 2  
	 indcon :  .byte  1  ;  
	 blncon :  .byte  1  ;   
     btcnt  :  .byte  1  ;   
	 btlst  :  .byte  1  ;   
     btfnlo :  .byte  1  ;    
     btfnhi :  .byte  1  ;    
	 btlong :  .byte  1  ;  

         .eseg 
	    .org  0x80
    ; 
    _tskn:   .db   0x01,0x01,0x01,0x01  ; 
 
    ;1 -    
    _ustlo:  .db   0x2C,0x2C,0x2C,0x2C  ;    30.0 C
    _usthi:  .db   0x01,0x01,0x01,0x01 	;   
	_tdnlo:  .db   0x64,0x64,0x64,0x64 	;     10.0 C
	_tdnhi:  .db   0x00,0x00,0x00,0x00  ;   
	_tuplo:  .db   0x20,0x20,0x20,0x20  ;    80.0 C
	_tuphi:  .db   0x03,0x03,0x03,0x03  ;   
	_offlo:  .db   0x00,0x00,0x00,0x00  ;   
	_offhi:  .db   0x00,0x00,0x00,0x00  ;   
	_onlo :  .db   0x00,0x00,0x00,0x00  ;   
	_onhi :  .db   0x00,0x00,0x00,0x00  ;   
	_timlo:  .db   0x00,0x00,0x00,0x00  ;   
	_timhi:  .db   0x00,0x00,0x00,0x00  ;   
    _gislo:  .db   0x0A,0x0A,0x0A,0x0A  ;  
    _gishi:  .db   0x00,0x00,0x00,0x00  ;  
	_corr :  .db   0x00,0x00,0x00,0x00  ; 
    _tmod :  .db   0x00,0x00,0x00,0x00  ;  

	;2 -  
    _iml  :  .db   0x00,0x00,0x00,0x00  ;   
    _imh  :  .db   0x00,0x00,0x00,0x00  ;   
    _imod :  .db   0x00,0x00,0x00,0x00  ;  , ,  


         .cseg
         .org 0

     rjmp  start
     rjmp  0 ;rjmp  service_INT0 ;  0  
     rjmp  0 ;rjmp  service_INT1 ;  1    
     rjmp  service_OC2  ; TCNT2  OCR2
     rjmp  service_OVF2 ; TCNT2       
     rjmp  0 ;rjmp  service_ICP1 ;  ICP1           
     rjmp  service_OC1A ; TCNT1  OCR1A 
     rjmp  0 ;rjmp  service_OC1B ; TCNT1  OCR1B  
     rjmp  0 ;rjmp  service_OVF1 ; TCNT1       
     rjmp  0 ;rjmp  service_OVF0 ; TCNT0       
     rjmp  0 ;rjmp  service_SPI  ;   SPI  
     rjmp  0 ;rjmp  service_URXC ;   USART 
     rjmp  0 ;rjmp  service_UDRE ; UDR  USART    
     rjmp  0 ;rjmp  service_UTXC ;   USART    
     rjmp  0 ;rjmp  service_ADCC ;            
     rjmp  0 ;rjmp  service_ERDY ;   EEPROM 
     rjmp  0 ;rjmp  service_ACI  ;    
     rjmp  0 ;rjmp  service_TWI  ;   TWI   
     rjmp  0 ;rjmp  service_SPMR ;  spm  

start:
     ldi   temp,high(RAMEND)  ; 
     out   SPH,temp
     ldi   temp,low(RAMEND)
     out   SPL,temp

	 clr   zero               ;   SRAM
     ldi   ZH,high(SRAM_START)
     ldi   ZL,low(SRAM_START)
     ldi   YH,high(SRAM_SIZE)
     ldi   YL,low(SRAM_SIZE)
     st    Z+,zero
     sbiw  YH:YL,1
     brne  PC-2
	  
     out   PORTB,zero
	 out   PORTC,zero
     out   PORTD,zero
	 ldi   temp,0b00111100
	 out   DDRB,temp
	 ldi   temp,0b00111111
	 out   DDRC,temp
	 ldi   temp,0b11110000
	 out   DDRD,temp
     ldi   temp,0b00000111
	 out   PORTD,temp
 
	 ldi   temp,(1<<CS22)|(1<<CS21)
     out   TCCR2,temp      ;CTC, F/256 = 8000000/256 = 31250 
	 ldi   temp,177        ;FOC2 = 31250/52 = 601  
     out   TCNT2,temp  
     ldi   temp,182        
     out   OCR2,temp 

	 out   TCCR1A,zero
     ldi   temp,(1<<WGM12)|(1<<CS11)|(1<<CS10)
     out   TCCR1B,temp   ;F/64 = 15625    CTC 
     ldi   temp,high(62499)
     out   OCR1AH,temp
     ldi   temp,low(62499)
     out   OCR1AL,temp

	 ldi   temp,high(simbol2) ;    
	 sts   poshi,temp         ;    
     ldi   temp,low(simbol2)
	 sts   poslo,temp

     ldi   temp,high(dummy) 
	 sts   btfnhi,temp      
     ldi   temp,low(dummy)
	 sts   btfnlo,temp
	
	 ldi   wrdhi,high(_tskn)  
     ldi   wrdlo,low(_tskn)   
	 rcall ee_read_check
	 mov   tskn,temp
     mov   temp3,temp

 	 ldi   temp,(1<<TOIE2)|(1<<OCIE2)
     out   TIMSK,temp

     ldi   wrdhi,high(400) 
     ldi   wrdlo,low(400)
     rcall press_btn
     rcall del100uS
	 cpi   buton,1
	 breq  task
	 sbiw  wrdhi:wrdlo,1
	 brne  PC-5
     rjmp  goto

task:
     ldi   temp,19
	 sts   ind0,temp
     sts   ind2,temp
  	 sts   ind1,temp3
     ldi   temp,high(entry) 
	 sts   btfnhi,temp      
     ldi   temp,low(entry)
	 sts   btfnlo,temp
     sei
     sbrs  temp3,7
     rjmp  PC-1
     cli
     cbr   temp3,1<<7
     ldi   temp,high(dummy) 
	 sts   btfnhi,temp      
     ldi   temp,low(dummy)
	 sts   btfnlo,temp
     mov   temp,temp3 
	 push  temp3        
	 ldi   wrdhi,high(_tskn)  
     ldi   wrdlo,low(_tskn)   
     rcall ee_write_check
	 mov   tskn,temp3
     pop   temp3 
     sei

     ldi   temp,15
	 sts   ind1,temp
	 ldi   temp,18
	 sts   ind2,temp
     cpi   temp3,1
	 breq  task1
	 cpi   temp3,2
	 breq  task2
     ldi   temp,20
	 sts   ind0,temp
	 ldi   temp,20
	 sts   ind1,temp
	 ldi   temp,21
	 sts   ind2,temp
     rjmp  PC
		 
task1:
     ldi   temp,1
     sts   ind0,temp
	 rjmp  PC
task2:
     ldi   temp,2
     sts   ind0,temp
	 rjmp  PC

goto:
     cpi   temp3,1
	 brne  PC+2
	 rjmp  goto1
     cpi   temp3,2
	 brne  PC+2
	 rjmp  goto2
     ldi   temp,20
	 sts   ind0,temp
	 ldi   temp,20
	 sts   ind1,temp
	 ldi   temp,21
	 sts   ind2,temp
	 sei
     rjmp  PC
     
goto1:
  .include "no1.asm"   ;
goto2:
  .include "no2.asm"   ;

	 rjmp  PC
    
entry:
     sts   ind1,temp3
     cpi   buton,1 
     brne  e1
     sbr   temp3,1<<7
     ret
e1:  cpi   buton,2
     brne  e2
     clr   buton
	 dec   temp3
	 brne  PC+2
	 ldi   temp3,2
	 ret
e2:  cpi   buton,3
     brne  e3
     clr   buton
     inc   temp3
     cpi   temp3,3
	 brne  PC+2
	 ldi   temp3,1
	 ret
e3:  clr   buton
     ret

ee_read_check:
     set              
     rcall read_byte   
     in    temp,EEDR   
     rcall read_byte   
     in    temp1,EEDR 
     rcall read_byte   
     in    temp2,EEDR 
     rcall read_byte  
     in    temp3,EEDR  
     sbiw  wrdlo,4     
     push  temp        
     and   temp,temp1  
     and   temp,temp2
     and   temp,temp3
     pop   temp       
     brne  rc1         
     clt              
     ret               
rc1: cp    temp,temp1    
     brne  rc2           
     push  temp
     rjmp  rc7
rc2: cp    temp,temp2    
     brne  rc3           
     push  temp
     rjmp  rc7
rc3: cp    temp,temp3   
     brne  rc4          
     push  temp
     rjmp  rc7
rc4: cp    temp1,temp2 
     brne  rc5          
     push  temp1
     rjmp  rc7
rc5: cp    temp1,temp3 
     brne  rc6         
     push  temp1
     rjmp  rc7
rc6: cpse  temp2,temp3 
     ret               
     push  temp2
rc7: pop   temp         
     rcall ee_write_check  
     clt                
     ret	       

service_OC1A:  
     push  temp
     in    temp,SREG
     push  temp
	 push  temp1
	 push  wrdlo
	 push  wrdhi

	 mov   temp,tskn
	 cpi   temp,1
	 brne  PC+3
	 rcall tem_service
	 rjmp  snd
     cpi   temp,2
	 brne  snd
	 rcall tmr_service

snd: pop   wrdhi
	 pop   wrdlo
	 pop   temp1
     pop   temp
     out   SREG,temp
     pop   temp
     reti  

service_OC2: 
     reti

service_OVF2:
     wdr
     push  temp
     in    temp,SREG
     push  temp
	 push  temp1
	 push  temp2
	 push  wrdlo
	 push  wrdhi
	 push  ZH
	 push  ZL
	 ldi   temp,178
	 out   TCNT2,temp
     lds   temp,prs2lo
	 inc   temp
	 sts   prs2lo,temp
     cpi   temp,50
     brne  oc1
	 sts   prs2lo,zero
	 lds   temp,prs2hi
	 inc   temp
     sts   prs2hi,temp
oc1: lds   ZL,poslo
	 lds   ZH,poshi
     icall
oc2: pop   ZL
	 pop   ZH
	 pop   wrdhi
	 pop   wrdlo
	 pop   temp2
	 pop   temp1
     pop   temp
     out   SREG,temp
     pop   temp
     reti   
	 
simbol2:
     lds   temp,ind2
     rcall convert
     lds   temp,indcon
     push  temp3
     lds   temp3,prs2hi
  #ifdef __COMMON_CATODE__
     sbrc  temp,5
     sbr   temp2,SEG_H 
     sbrs  temp,2
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+3
     clr   temp1
     clr   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     clr   temp1
     clr   temp2
  #else
     sbrc  temp,5
     cbr   temp2,SEG_H 
     sbrs  temp,2
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+4
     ser   temp1
     ser   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     ser   temp1
     ser   temp2
  #endif
     pop   temp3
  #ifdef __COMMON_CATODE__
     sbi   PORTB,X0
     sbi   PORTB,X1
  #else
     cbi   PORTB,X0
     cbi   PORTB,X1
  #endif
     ori   temp2,0b00000111
     out   PORTC,temp1
	 out   PORTD,temp2
  #ifdef __COMMON_CATODE__
     cbi   PORTB,X2
  #else
     sbi   PORTB,X2
  #endif
     ldi   temp,high(simbol1) 
	 sts   poshi,temp         
     ldi   temp,low(simbol1)
	 sts   poslo,temp
     reti

simbol1:
     lds   temp,ind1
     rcall convert
     lds   temp,indcon
     push  temp3
     lds   temp3,prs2hi
  #ifdef __COMMON_CATODE__
     sbrc  temp,4
     sbr   temp2,SEG_H 
     sbrs  temp,1
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+3
     clr   temp1
     clr   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     clr   temp1
     clr   temp2
  #else
     sbrc  temp,4
     cbr   temp2,SEG_H 
     sbrs  temp,1
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+4
     ser   temp1
     ser   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     ser   temp1
     ser   temp2
  #endif
     pop   temp3
  #ifdef __COMMON_CATODE__
     sbi   PORTB,X0
     sbi   PORTB,X2
  #else
     cbi   PORTB,X0
     cbi   PORTB,X2
  #endif
     ori   temp2,0b00000111
     out   PORTC,temp1
	 out   PORTD,temp2
  #ifdef __COMMON_CATODE__
     cbi   PORTB,X1
  #else
     sbi   PORTB,X1
  #endif
     ldi   temp,high(simbol0) 
	 sts   poshi,temp         
     ldi   temp,low(simbol0)
	 sts   poslo,temp
     reti

simbol0:
     lds   temp,ind0
     rcall convert
     lds   temp,indcon
     push  temp3
     lds   temp3,prs2hi
  #ifdef __COMMON_CATODE__
     sbrc  temp,3
     sbr   temp2,SEG_H 
     sbrs  temp,0
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+3
     clr   temp1
     clr   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     clr   temp1
     clr   temp2
  #else
     sbrc  temp,3
     cbr   temp2,SEG_H 
     sbrs  temp,0
     rjmp  PC+14
     sbrs  temp,6
     rjmp  PC+6
     sbrs  temp3,0
     rjmp  PC+4
     ser   temp1
     ser   temp2
     rjmp  PC+7
     sbrs  temp,7
     rjmp  PC+5
     sbrs  temp3,1
     rjmp  PC+3
     ser   temp1
     ser   temp2
  #endif
     pop   temp3
  #ifdef __COMMON_CATODE__
     sbi   PORTB,X1
     sbi   PORTB,X2
  #else
     cbi   PORTB,X1
     cbi   PORTB,X2
  #endif
     ori   temp2,0b00000111
     out   PORTC,temp1
	 out   PORTD,temp2
  #ifdef __COMMON_CATODE__
     cbi   PORTB,X0
  #else
     sbi   PORTB,X0
  #endif
     ldi   temp,high(button) 
	 sts   poshi,temp        
     ldi   temp,low(button)
	 sts   poslo,temp
     reti

button:
  #ifdef __COMMON_CATODE__
     sbi   PORTB,X2
     sbi   PORTB,X1
     sbi   PORTB,X0
  #else
     cbi   PORTB,X2
     cbi   PORTB,X1
     cbi   PORTB,X0
  #endif
     rcall press_btn  
	 lds   ZH,btfnhi         
	 lds   ZL,btfnlo
     icall
     ldi   temp,high(simbol2) 
	 sts   poshi,temp         
     ldi   temp,low(simbol2)
	 sts   poslo,temp
     ret


press_btn:
     rcall btn_polling
	 mov   buton,temp2
	 tst   buton
	 brne  pr1
     sts   btlst,zero
	 sts   btcnt,zero
	 sts   btlong,zero 
	 clr   buton
     ret
pr1: lds   temp,btlst
	 cp    buton,temp
     sts   btlst,buton
	 breq  pr2
	 sts   btcnt,zero
	 sts   btlong,zero 
	 clr   buton
     ret
pr2: lds   temp1,btlong
	 cpi   temp1,150
	 breq  PC+2
	 inc   temp1
	 sts   btlong,temp1
     lds   temp,btcnt
     inc   temp
	 sts   btcnt,temp
     cpi   temp,70
     brne  pr4
	 lds   temp1,btlong
	 cpi   temp1,150
	 breq  PC+2
     subi  temp,3
     subi  temp,1
	 sts   btcnt,temp
     cpi   buton,1
	 brne  PC+4
     sts   btlong,zero
pr3: clr   buton
     ret
pr4: cpi   temp,4
     brne  pr3
     ret

btn_polling:
     clr   temp2 
     in    temp,PIND
     com   temp
     andi  temp,0b00000111
     cpi   temp,0b00000001
     brne  PC+3
     ldi   temp2,3
     ret
     cpi   temp,0b00000010
     brne  PC+3
     ldi   temp2,1
     ret
     cpi   temp,0b00000100
     brne  PC+2
     ldi   temp2,2
     ret 

convert:
     ldi   ZH,high(2*led_tabl)
     ldi   ZL,low(2*led_tabl)
	 lsl   temp
	 inc   temp
     add   ZL,temp
     adc   ZH,zero
     lpm   temp,Z
	 ldi   ZL,182
     out   OCR2,ZL
	 in    temp1,PORTC
	 cbr   temp1,0b00001111
     push  temp
     cbr   temp,0b11110000
	 or    temp1,temp
	 pop   temp
	 in    temp2,PORTD
     cbr   temp2,0b11110000
     cbr   temp,0b00001111
	 or    temp2,temp
     ret  
	 	
bin_dec:
     clr   wait
bin_dec_ex:
     push  temp
	 push  temp1
	 push  temp2
     push  wrdhi
     push  wrdlo
	 clt
     sbrs  wrdhi,7
	 rjmp  bd0
     set
	 com   wrdhi
	 com   wrdlo
	 adiw  wrdhi:wrdlo,1
bd0: lds   temp2,blncon
     clr   temp
bd1: subi  wrdlo,low(100)
	 sbci  wrdhi,high(100)
	 inc   temp
	 brcc  bd1
	 subi  wrdlo,low(-100)
	 sbci  wrdhi,high(-100)
	 dec   temp
	 sbrc  temp2,0
	 rjmp  bd2
	 brne  bd2
	 ldi   temp,10
bd2: sts   ind2,temp
	 lds   temp,ind2
     clr   temp1
bd3: sbiw  wrdhi:wrdlo,10
	 inc   temp1
	 brcc  bd3
     adiw  wrdhi:wrdlo,10
     dec   temp1
	 sbrc  temp2,0
	 rjmp  bd4
	 brne  bd4
	 cpi   temp,10
	 brne  bd4
     ldi   temp1,10
bd4: sts   ind1,temp1
	 sts   ind0,wrdlo
	 brtc  bd5
	 ldi   temp,19   ;-
	 sts   ind2,temp
bd5: pop   wrdlo
     pop   wrdhi
	 pop   temp2
	 pop   temp1
	 pop   temp
	 ret

show_start:	 
	 adc   ZH,zero
	 lpm   temp,Z+
	 sts   ind2,temp
	 lpm   temp,Z+
	 sts   ind1,temp
	 lpm   temp,Z+
	 sts   ind0,temp 
	 ret
	 
hello_tabl:
 .db 10,10,36,21,14,14,0,10,10,10 

led_tabl:
 #ifdef __COMMON_CATODE__ 
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A)         ; 0      0
 .db 0,0|(SEG_C)|(SEG_B)                                         ; 1      1
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_D)|(SEG_B)|(SEG_A)                 ; 2      2
 .db 0,0|(SEG_G)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A)                 ; 3      3
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_C)|(SEG_B)                         ; 4      4
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_D)|(SEG_C)|(SEG_A)                 ; 5      5
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_A)         ; 6      6
 .db 0,0|(SEG_C)|(SEG_B)|(SEG_A)                                 ; 7      7
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A) ; 8      8
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_D)|(SEG_C)|(SEG_B)|(SEG_A)         ; 9      9
 .db 0,0                                                         ; space 10
 .db 0,0|(SEG_E)|(SEG_D)|(SEG_C)                                 ; u     11
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_C)                         ; h     12
 .db 0,0|(SEG_E)                                                 ; i     13
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_D)                                 ; l     14
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_D)|(SEG_C)                         ; o     15
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_B)                 ; d     16	
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)                         ; t     17
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_C)                                 ; n     18
 .db 0,0|(SEG_G)                                                 ; -     19
 .db 0,0|(SEG_G)|(SEG_E)                                         ; r     20
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_A)                 ; E     21
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_D)|(SEG_C)|(SEG_A)                 ; S     22
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_A)                         ; C     23
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_C)|(SEG_B)|(SEG_A)                 ;      24
 .db 0,0|(SEG_F)|(SEG_E)                                         ; I     25
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_A)                         ; F     26
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_A)                                 ;      27
 .db 0,0|(SEG_F)|(SEG_C)|(SEG_B)|(SEG_A)                         ; T     28
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_B)|(SEG_A)                 ; P     29
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_B)                 ; U     30
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_B)|(SEG_A)                         ; grad  31
 .db 0,0|(SEG_A)                                                 ; ~     32
 .db 0,0|(SEG_D)                                                 ; _     33
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_D)                                 ; c     34
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_D)|(SEG_C)|(SEG_B)                 ;      35	
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_C)|(SEG_B)                 ;      36
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_C)|(SEG_B)|(SEG_A)         ;      37
 .db 0,0|(SEG_F)|(SEG_E)|(SEG_B)|(SEG_A)                         ; M     38
 .db 0,0|(SEG_G)|(SEG_F)|(SEG_E)|(SEG_D)|(SEG_C)                 ; b     39
 .db 0,0|(SEG_G)|(SEG_E)|(SEG_D)|(SEG_C)|(SEG_B)                 ; d     40

 #else
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_B)&(SEG_A)         ; 0      0
 .db 0,0xFF&(SEG_C)&(SEG_B)                                         ; 1      1
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_D)&(SEG_B)&(SEG_A)                 ; 2      2
 .db 0,0xFF&(SEG_G)&(SEG_D)&(SEG_C)&(SEG_B)&(SEG_A)                 ; 3      3
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_C)&(SEG_B)                         ; 4      4
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_D)&(SEG_C)&(SEG_A)                 ; 5      5
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_A)         ; 6      6
 .db 0,0xFF&(SEG_C)&(SEG_B)&(SEG_A))                                ; 7      7
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_B)&(SEG_A) ; 8      8
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_D)&(SEG_C)&(SEG_B)&(SEG_A)         ; 9      9
 .db 0,0xFF                                                         ; space 10
 .db 0,0xFF&(SEG_E)&(SEG_D)&(SEG_C)                                 ; u     11
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_C)                         ; h     12
 .db 0,0xFF&(SEG_E)                                                 ; i     13
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_D)                                 ; l     14
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_D)&(SEG_C)                         ; o     15
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_B)                 ; d     16	
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)                         ; t     17
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_C)                                 ; n     18
 .db 0,0xFF&(SEG_G)                                                 ; -     19
 .db 0,0xFF&(SEG_G)&(SEG_E)                                         ; r     20
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_A)                 ; E     21
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_D)&(SEG_C)&(SEG_A)                 ; S     22
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_A)                         ; C     23
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_C)&(SEG_B)&(SEG_A)                 ;      24
 .db 0,0xFF&(SEG_F)&(SEG_E)                                         ; I     25
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_A)                         ; F     26
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_A)                                 ;      27
 .db 0,0xFF&(SEG_F)&(SEG_C)&(SEG_B)&(SEG_A)                         ; T     28
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_B)&(SEG_A)                 ; P     29
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_B)                 ; U     30
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_B)&(SEG_A)                         ; grad  31
 .db 0,0xFF&(SEG_A)                                                 ; ~     32
 .db 0,0xFF&(SEG_D)                                                 ; _     33
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_D)                                 ; c     34
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_D)&(SEG_C)&(SEG_B)                 ;      35	
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_C)&(SEG_B)                 ;      36
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_C)&(SEG_B)&(SEG_A)         ;      37
 .db 0,0xFF&(SEG_F)&(SEG_E)&(SEG_B)&(SEG_A)                         ; M     38                                                           ;       39
 .db 0,0xFF&(SEG_G)&(SEG_F)&(SEG_E)&(SEG_D)&(SEG_C)                 ; b     39
 .db 0,0xFF&(SEG_G)&(SEG_E)&(SEG_D)&(SEG_C)&(SEG_B)                 ; d     40
 #endif
