reset_lan:
     cbi   PORTDS,DS
     sbi   DDRDS,DS
	 ldi   cntlo,low(500)   ;500 uS
     ldi   cnthi,high(500)
	 rcall delay
     cbi   DDRDS,DS
	 ldi   cntlo,low(65)    ;65 uS
     ldi   cnthi,high(65)
	 rcall delay
     sbis  PINDS,DS
	 rjmp  PC+3
	 ldi   error,1          ;  Hi
	 ret
	 ldi   cntlo,low(500)   ;500 uS
     ldi   cnthi,high(500)
	 rcall delay
     sbic  PINDS,DS
	 rjmp  PC+3
	 ldi   error,2          ;  Lo
	 ret
	 clr   error
	 ret

read_slot:
     cbi   PORTDS,DS
     sbi   DDRDS,DS
	 ldi   cntlo,low(2)     ;5 uS
     ldi   cnthi,high(2)
	 rcall delay
	 cbi   DDRDS,DS
	 ldi   cntlo,low(11)    ;13 uS
     ldi   cnthi,high(11)
	 rcall delay
	 clt
	 sbic  PINDS,DS
	 set
	 ldi   cntlo,low(45)    ;45 uS
     ldi   cnthi,high(45)
	 rcall delay
	 ret

read_rom:
     rcall reset_lan
	 in    temp,TIMSK	
     cbr   temp,(1<<OCIE1A)|(1<<TOIE2)
     out   TIMSK,temp 
     ldi   temp3,0x33      ;Read ROM
	 rcall write_byte
	 clr   temp
rr1: rcall read_byte_lan
	 rcall conver_idsn
	 inc   temp
	 cpi   temp,8
	 brne  rr1
	 in    temp,TIMSK	
     sbr   temp,(1<<OCIE1A)|(1<<TOIE2)
     out   TIMSK,temp 
	 ret

conver_termo:
     rcall reset_lan
 	 tst   error
	 breq  ct1
     rcall read_rom
	 cbr   flag,1<<7
	 rjmp  conver_termo
ct1: sbr   flag,1<<7
     ldi   temp3,0xCC      ;Skip ROM
	 rcall write_byte
	 ldi   temp3,0x44
	 in    temp,TIMSK	
     cbr   temp,(1<<OCIE1A)|(1<<TOIE2)
     out   TIMSK,temp 
	 rcall write_byte
	 sbi   PORTDS,DS
     sbi   DDRDS,DS
	 in    temp,TIMSK	
     sbr   temp,(1<<OCIE1A)|(1<<TOIE2)
     out   TIMSK,temp  
	 ret

result_termo:
     rcall reset_lan
 	 tst   error
	 breq  rt0
	 rcall read_rom
	 cbr   flag,1<<7
	 rjmp  result_termo
rt0: sbr   flag,1<<7
     ldi   temp3,0xCC      ;Skip ROM
     rcall write_byte
	 ldi   temp3,0xBE
	 rcall write_byte
	 rcall read_byte_lan
	 mov   wrdlo,temp3
	 rcall read_byte_lan
 	 mov   wrdhi,temp3 
	 bld   wrdhi,7
	 brtc  rt1
     com   wrdlo
	 com   wrdhi
	 adiw  wrdhi:wrdlo,1
rt1: swap  wrdhi
     cbr   wrdhi,0b00001111
	 mov   temp,wrdlo
	 cbr   wrdlo,0b00001111
     swap  wrdlo
	 or    wrdlo,wrdhi
	 clr   wrdhi
	 cli
	 push  R0
	 push  R1
	 ldi   temp1,10
	 mul   wrdlo,temp1
	 movw  wrdlo,R0
     cbr   temp,0b11110000
     mul   temp,temp1
	 swap  R0
	 ldi   temp2,0b00001111
	 and   R0,temp2
	 add   wrdlo,R0
	 pop   R1
	 pop   R0
	 adc   wrdhi,zero
	 sei
	 brtc  rt2
	 clt
     com   wrdlo
	 com   wrdhi
	 adiw  wrdhi:wrdlo,1
rt2: ser   temp
     sbrs  corr,7
     clr   temp
     add   wrdlo,corr
     adc   wrdhi,temp
	 lds   temp,errcnt
	 cpi   temp,2
	 brne  rt3
	 sts   errcnt,zero
     sts   tsavlo,wrdlo
     sts   tsavhi,wrdhi
	 movw  temlo,wrdlo
	 ret
rt3: lds   temp1,tsavhi
     lds   temp,tsavlo
	 push  wrdlo
	 push  wrdhi
	 sub   wrdlo,temp
     sbc   wrdhi,temp1
	 sbrc  wrdhi,7
	 rjmp  rt4
	 cpi   wrdlo,low(250)
	 ldi   temp,high(250)
	 cpc   wrdhi,temp
	 rjmp  rt5
rt4: com   wrdlo
     com   wrdhi
	 adiw  wrdhi:wrdlo,1
	 cpi   wrdlo,low(80)
	 ldi   temp,high(80)
	 cpc   wrdhi,temp
rt5: pop   wrdhi
     pop   wrdlo
	 brcc  rt6
	 sts   errcnt,zero
     sts   tsavlo,temlo
     sts   tsavhi,temhi
	 movw  temlo,wrdlo
	 ret
rt6: lds   temp,errcnt
     inc   temp
     sts   errcnt,temp
	 ret
	 
conver_idsn:
	 ldi   ZL,low(dsnum)
	 ldi   ZH,high(dsnum)
     lsl   temp
     add   ZL,temp
     adc   ZH,zero
	 lsr   temp
	 push  temp3
	 swap  temp3
	 cbr   temp3,0b11110000
	 rcall conver_sim
	 st    Z+,temp3
	 pop   temp3
	 cbr   temp3,0b11110000
	 rcall conver_sim
	 st    Z,temp3
	 ret

conver_sim:
     cpi   temp3,10
	 brcc  cm1
	 ret
cm1: cpi   temp3,10
	 brne  cm2
     ldi   temp3,37  ;A
	 ret
cm2: cpi   temp3,11
	 brne  cm3
     ldi   temp3,39  ;b
	 ret
cm3: cpi   temp3,12
	 brne  cm4
     ldi   temp3,23  ;C
	 ret
cm4: cpi   temp3,13
	 brne  cm5
     ldi   temp3,40  ;d
	 ret
cm5: cpi   temp3,14
	 brne  cm6
     ldi   temp3,21  ;E
	 ret
cm6: ldi   temp3,26  ;F
	 ret











     




